!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!modules.f90. Now only contains BTT signal to noise if you have bispectrum!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module modules

  use settings
  use CMBFlat
  use interpolation
  implicit none


contains 

  subroutine Get_SN_BTT(testlmax)

    integer  :: testlmax
    integer  :: lx1, ly1, lx2, ly2, l1crossl2, il, l1, l2, l3, ilmax
    integer  :: lx1i, lx2i, ly1i, ly2i
    integer  :: NearIntLength, NearIntl1, NearIntL2
    real(dl) :: lengthl1l2, lengthl1, lengthl2
    real(dl) :: DSN3, DSN4, DSN1, DSN2
    real(dl)    :: Bnoise(5000), Tnoise(5000), sigmaBTT, sigmaBTT2
    character(120) :: B_BTTfile, SNfile, NoiseDataB, NoiseDataT
    real(dl),allocatable:: Blll(:,:,:)
    integer :: j,i,s,w, ell1, ell2, ell3
    real(dl) :: Rell, B2
    integer :: deltaell
    integer :: ellarrS(2500)
    integer :: ellarrT(2500) 
    integer :: Dummyell
    real(dl)  :: a3j(0:10000)
    real(dl) :: y1, y2, s1, s2, s3
    real(dl), allocatable  :: integrand2d(:, :)
    real(dl), allocatable  :: integrand3d(:, :)
    real(dl), allocatable  :: w3j(:,:,:)
    logical :: want_integrand
    logical :: cosmic_variance, PrimTens
    logical :: want3D
    logical :: want_SN_3D_lmin
    logical :: BeamNoiseGrid
    integer :: resboost  = 1
    integer :: DownSamp
    real(dl) :: testell
    integer :: llmaxT, ilTmax
    real(dl) :: beam = 0
    integer ::  beamsteps = 10, noisesteps
    real(dl) :: w0T = 1.d0
    real(dl) :: w0B = sqrt(2.d0)
    real(dl) :: fsky

    cosmic_variance  = .true.
    PrimTens = .true.
    BeamNoiseGrid  = .false.
    TtoS = 0.01
    want_integrand = .false. 
    scalars  = .true. 
    polarization = .true.
    want3D = .false.
    want_SN_3D_lmin = .false.
    !for now we can only do this. 
    AppLSS = .true.

    call Compute_CL_flat
    !it determines lmax from the Cl's 
    if (testlmax .eq. 0) testlmax = public_intlmaxS

    !DownSamp = 5
    !testlmax = int(256/DownSamp)
    llmaxT =  public_intlmaxPolTens!int(256/DownSamp)
    write(*,*) testlmax, llmaxT

    !testing linear interpolation
    open(unit=28,file='testcl.txt', status="replace")
!!$    do i = 1, 4500
!!$       testell = i + 10
!!$       call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,testell,s1)
!!$       write(28,*) testell, s1
!!$    enddo
!!$    close(28)
!!$    stop

    !for now, not pretty. 
    deltaell  = lstep
    if (AppLss) then 
       B_BTTfile = Trim(homefolder)//Trim(rootnameBl)//trim('_BTT_full.txt')
       SNfile = Trim(homefolder)//Trim(rootnameBl)//trim('BTT_SN.txt')
       NoiseDataB = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_CMB-S4.txt')
       NoiseDataT = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_T_CMB-S4.txt')
       !other experiments:

       !noise_B_Planck.txt
       !noise_T_Planck.txt

       !noise_N_spider.txt

       !noise_T_SPTpol.txt
       !noise_B_Bicep-Keck.txt
       !NoiseData = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_Bicep-Keck.txt')

    else
       B_BTTfile = Trim(homefolder)//Trim(rootnameBl)//trim('_Blll_BTTb.txt')
       SNfile = Trim(homefolder)//Trim(rootnameBl)//trim('BTT_SN.txt')
       ! NoiseData = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_CMB-S4.txt')
       NoiseDataB = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_Bicep-Keck.txt')


    endif
    !B_BTTfile = 'BTT_equil_sorted.txt'
    allocate(Blll(llmaxT,testlmax,testlmax))
    Blll = 0.0

    open(unit=28,file=B_BTTfile, status="old")
    write(*,'(A40)') "<<<<<<<<<<<< Reading B-file >>>>>>>>>>>>"
    do j = 1, testlmax !loop over ells
       !ell1 = ellarrS(j)
       !write(*,*) ell1
       do i = j, testlmax !only for i .ge. j
          !ell2 = ellarrS(i)
          do s = 1, llmaxT !should do all ell   
             !ell3 = ellarrT(s)
             !read(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             read(28,*) ell1, ell2, ell3, Blll(s,i,j)
             !write(*,*) ell1, ell2, ell3, Blll(s,i,j)
             !association. Needed for S/N. 

             Blll(s,j,i) = -Blll(s,i,j) !or "+", does not matter since it is squared
             ellarrT(s) = ell3
          enddo
       enddo
       ellarrS(j) = ell1
       !write(*,*) ell1
    enddo
    close(28)
    !stop
!!$    open(unit=8,file = '../data/BTT_3d.dat', &
!!$         form='unformatted', access='direct', recl = 8 * testlmax * testlmax * lmaxT)
!!$    write(unit=8,rec=1) Blll(:,:,:) 
!!$    close(unit=8)

   ! open(unit=28,file=NoiseDataB , status="old")
   ! do i  = 1, 4500
   !    read(28,*) Rell, Bnoise(i) !in muK^2, i = 1 -> ell  = 2
   ! enddo
   ! close(28)
   ! open(unit=28,file=NoiseDataT , status="old")
   ! do i  = 1,4800
   !    read(28,*) Rell, Tnoise(i) !in muK^2, i = 1 -> ell  = 2
   ! enddo
   ! close(28)
!commented out hwinch august 6


    if (want3D .or. BeamNoiseGrid) then 
       allocate(w3j(2*testlmax+1,2*testlmax+1,2*testlmax+1))
       do j = 1, testlmax
          ell1 = ellarrS(j)
          do i = j, testlmax
             ell2 = ellarrS(i)
             call GetThreeJs(a3j((abs(ell2-ell1)):(ell2+ell1)),ell1, ell2,0,0)
             do s = i, i+j !is tis all?
                ell3 = ellarrS(s)
                if(ellarrS(s) .gt. ell1+ell2) exit
                !store wigner 3j:

                w3j(s,i,j) = a3j(ell3)
                w3j(s,j,i) = w3j(s,i,j)
                w3j(i,s,j) = w3j(s,i,j)
                w3j(j,i,s) = w3j(s,i,j)
                w3j(i,j,s) = w3j(s,i,j)
                w3j(j,s,i) = w3j(s,i,j)

             enddo
          enddo
       enddo
    endif



    if (want3D) then

       open(unit=28,file='../data/SN_BTT3D_CMBS4xCMBS4_equil_r_1.0.txt', status="replace")
       if (resboost .ne. 1) then
          ilmax  = (testlmax-1)*resboost
          ilTmax = (llmaxT-1)*resboost
          deltaell = deltaell/resboost
          write(*,*) ilmax, deltaell
       else
          ilmax = testlmax
          ilTmax = llmaxT
       endif
       allocate(integrand3d(ilTmax, ilmax))
       integrand3d = 0.0
       do il = 5*resboost, ilmax, 5*resboost
          !il = ilmax
          DSN3 = 0.0d0
          !il = ilmax
          do s = 1, ilTmax, 1 !loop over ells
             if (resboost .ne. 1) then
                ell1 = lmin + (s-1)*deltaell
             else            
                ell1 = ellarrS(s)
                !write(*,*) ell1
             endif
             DSN2 = 0.0d0
             do j = 1, il, 1 !only for i .ge. j
                if (resboost .ne. 1) then
                   ell2 = lmin + (j-1)*deltaell
                else            
                   ell2 = ellarrS(j)
                endif
                DSN1 = 0.0d0
                do i = j, il, 1 
                   if (resboost .ne. 1) then
                      ell3 = lmin + (i-1)*deltaell
                      call OneDlinear_interpolation(lmin,testlmax,ClTT,real(ell2,8),lstep,s1)
                      call OneDlinear_interpolation(lmin,testlmax,ClTT,real(ell3,8),lstep,s2)
                      call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,Blll, &
                           real(ell1,8),real(ell2,8),real(ell3,8),lstep,y1)
                   else            
                      ell3 = ellarrS(i)
                      s1 = ClTT(j)
                      s2 = ClTT(i)
                      s3 = ClBB(s)
                      y1 = Blll(s,i,j)
                   endif

                   B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                   !B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                   !*((4*pi)**2*sqrt(2.)/2.)**2 
                   !write(*,*) LargeArg3Js(ell1,ell2,ell3)**2


                   if(cosmic_variance) then 
                      sigmaBTT = s1*s2*Bnoise(ellarrS(s)-9)*(2*pi)**2 &
                           *DeltaBis(ell2,ell3,ell1)
                   elseif(PrimTens) then 
                      sigmaBTT = (Bnoise(ellarrS(s)-9)+s3*(2*pi))* &
                           (Tnoise(ellarrS(i)-9)+s2*(2*pi))* &
                           (Tnoise(ellarrS(j)-9)+s1*(2*pi))* &
                           DeltaBis(ell2,ell3,ell1)                 
                   else                   
                      sigmaBTT = (Bnoise(ellarrS(s)-9))* &
                           (Tnoise(ellarrS(i)-9)+s2*(2*pi))* &
                           (Tnoise(ellarrS(j)-9)+s1*(2*pi))* &
                           DeltaBis(ell2,ell3,ell1)
                   endif
                   DSN1 = DSN1 + B2/(sigmaBTT)*(ellarrS(i+1)-ellarrS(i))
                   !DSN1 = DSN1 + B2/(sigmaTTT)*(deltaell)
                   !write(*,*) 'DSN1:',DSN1
                   !if (il .eq. ) then
                   integrand3d(s,j) = integrand3d(s,j) + B2/(sigmaBTT)*(deltaell)**3
                   !write(*,*) integrand3d(s,j)
                   !endif
                enddo
                DSN2 = DSN2 + DSN1*(ellarrS(j+1)-ellarrS(j))

             enddo
             DSN3 = DSN3 + DSN2*(ellarrS(s+1)-ellarrS(s))
          enddo
          !the factor 4 comes from the tranfer functions. This needs to be fixed. 
          write(28,*) ell2, 4.0*sqrt(1.d0/DSN3/2.0)
          write(*,*) ell2, 4.0*sqrt(1.d0/DSN3/2.0)
       enddo
       close(28)

!!$    do i = 1, ilmax
!!$       do j = 1, ilmax
!!$          write(*,*) i,j,integrand3d(i,j)
!!$       enddo
!!$    enddo
       open(unit=8,file = '../data/integrand3d_deltaell_4_BICEPxSPT_btt.dat', &
            form='unformatted', status="replace", access='direct', recl = 8 * (ilmax) * (ilTmax))
       write(unit=8,rec=1) integrand3d(:,:) 
       close(unit=8)
       deallocate(integrand3d)
    endif
    !for testing:
!!$    do i = 1, 5000
!!$       write(*,*) i, Noise_l(1.d0, 1.d0,i)
!!$    enddo 
    if(BeamNoiseGrid) then
       open(unit=28,file='../data/SN_BTT3D_planckxplanck_beam_fsky_equil_r_0.01.txt', status="replace")
       beam = 0
       beamsteps = 5!46
       noisesteps = 5!46
       w0T = 0.8d0
       w0B = sqrt(2.d0)
       fsky = 0.7
       ilmax = 256
       ilTmax = 131
       do w = 1, noisesteps
          beam = 4.d0 !0.8d0
          fsky = fsky + 0.01
          !number below is determined from
          !having s = 1 for fsky =  0.4
          !w0T = 1.58114*sqrt(fsky)
          !for Planck
          !having s = 30 for fsky =  1.0
          w0T = 30.d0*sqrt(fsky)
          !w0T = w0T +  0.2d0
          !w0B = sqrt(2.d0)*w0T
          
          !for planck
          w0B = 2.d0*w0T
	  do il = 1, beamsteps

             !set beam (defaul for CMB-S4 is 1-10)
             beam = beam + 0.2d0

             !il = ilmax
             DSN3 = 0.0d0
             !il = ilmax
             do s = 21, ilTmax, 1 !lmin  = 30
                ell1 = ellarrS(s)
                DSN2 = 0.0d0
                do j = 21, ilmax, 1 !only for i .ge. j
                   ell2 = ellarrS(j)
                   DSN1 = 0.0d0
                   do i = j, ilmax, 1 

                      ell3 = ellarrS(i)
                      s1 = ClTT(j)
                      s2 = ClTT(i)
                      s3 = ClBB(s)
                      y1 = Blll(s,i,j)

                      B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                      !B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                      !*((4*pi)**2*sqrt(2.)/2.)**2 
                      !write(*,*) LargeArg3Js(ell1,ell2,ell3)**2


                      if(cosmic_variance) then 
                         sigmaBTT = s1*s2*Noise_l(beam,w0B,ell1)*(2*pi)**2 &
                              *DeltaBis(ell2,ell3,ell1)
                      elseif(PrimTens) then 
                         sigmaBTT = (Noise_l(beam,w0B,ell1)+s3*(2*pi))* &
                              (Noise_l(beam,w0T,ell3)+s2*(2*pi))* &
                              (Noise_l(beam,w0T,ell2)+s1*(2*pi))* &
                              DeltaBis(ell2,ell3,ell1)                 
                      else                   
                         sigmaBTT = (Noise_l(beam,w0B,ell1))* &
                              (Noise_l(beam,w0T,ell3)+s2*(2*pi))* &
                              (Noise_l(beam,w0T,ell2)+s1*(2*pi))* &
                              DeltaBis(ell2,ell3,ell1)
                      endif
                      DSN1 = DSN1 + y1**2/(sigmaBTT)*(ellarrS(i+1)-ellarrS(i))

                   enddo
                   DSN2 = DSN2 + DSN1*(ellarrS(j+1)-ellarrS(j))

                enddo
                DSN3 = DSN3 + DSN2*(ellarrS(s+1)-ellarrS(s))
             enddo
          !the factor 4 comes from the tranfer functions. This needs to be fixed. 
          write(28,*) fsky, beam, 4.0*sqrt(1.d0/DSN3/2.0)/sqrt(fsky), DSN3
          write(*,*) fsky, beam, 4.0*sqrt(1.d0/DSN3/2.0)/sqrt(fsky), DSN3
          enddo

       enddo
       close(28)

    endif
    
    !stop

    if(want_SN_3D_lmin) then 
       open(unit=28,file='../data/SN_lmin_BTT3D_CMBS4xCMBS4test2_dell4.txt', status="replace")
       if (resboost .ne. 1) then
          ilmax  = (testlmax-1)*resboost
          ilTmax = (llmaxT-1)*resboost
          !deltaell = deltaell/resboost
          write(*,*) ilmax, deltaell
       else
          ilmax = testlmax
          ilTmax = llmaxT
       endif
       allocate(integrand3d(ilmax, ilmax))
       integrand3d = 0.0
       do il =1, ilTmax, 2*resboost
          !il = testlmax
          DSN3 = 0.0d0
          !il = ilmax
          do s = il, ilTmax, 1 !loop over ells
             if (resboost .ne. 1) then
                ell1 = lmin + (s-1)*deltaell
             else            
                ell1 = ellarrS(s)
             endif
             DSN2 = 0.0d0
             do j = il, ilmax, 1 !only for i .ge. j
                if (resboost .ne. 1) then
                   ell2 = lmin + (j-1)*deltaell
                else            
                   ell2 = ellarrS(j)
                endif
                DSN1 = 0.0d0
                do i = j, ilmax, 1 
                   if (resboost .ne. 1) then
                      ell3 = lmin + (i-1)*deltaell
                      call OneDlinear_interpolation(lmin,testlmax,ClTT,real(ell2,8),lstep,s1)
                      call OneDlinear_interpolation(lmin,testlmax,ClTT,real(ell3,8),lstep,s2)
                      call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,Blll, &
                           real(ell1,8),real(ell2,8),real(ell3,8),lstep,y1)
                   else            
                      ell3 = ellarrS(i)
                      s1 = ClTT(j)
                      s2 = ClTT(i)
                      y1 = Blll(s,i,j)
                   endif

                   !B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                   B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                   !*((4*pi)**2*sqrt(2.)/2.)**2 



                   if(cosmic_variance) then 
                      sigmaBTT = s1*s2*Bnoise(9+int(deltaell)*(s-1))*(2*pi)**2 &
                           *DeltaBis(ell2,ell3,ell1)
                   else
                      sigmaBTT = (Bnoise(9+int(deltaell)*(s-1)))* &
                           (Tnoise(9+int(deltaell)*(i-1))+s2*(2*pi))* &
                           (Tnoise(9+int(deltaell)*(j-1))+s1*(2*pi))
                   endif
                   DSN1 = DSN1 + B2/(sigmaBTT)*(deltaell)
                   !write(*,*) 'DSN1:',DSN1
                   !if (il .eq. ) then
                   !integrand3d(s,j) = integrand3d(s,j) + B2/(sigmaBTT)*(deltaell)**3
                   !write(*,*) integrand3d(s,j)
                   !endif
                enddo
                DSN2 = DSN2 + DSN1*deltaell
                !write(*,*) DSN2
             enddo
             DSN3 = DSN3 + DSN2*deltaell
          enddo
          DSN3 = DSN3 !multiply by multiplicity
          !DSN3 = DSN3
          write(28,*) lmin + (il-1)*deltaell, sqrt(2.0/DSN3)
          write(*,*) lmin + (il-1)*deltaell, sqrt(2.0/DSN3)
       enddo
       close(28)
    endif
    
    write(*,'(A40)') "I'm here"

    if(want_integrand) then

       Dummyell = 20
       deltaell = Dummyell
       allocate(integrand2d(lmaxScal/Dummyell, lmaxScal/Dummyell))
       integrand2d = 0
       write(*,'(A40)') "<<<<<<<<<<<<   Integrand   >>>>>>>>>>>>>"
       il = 4400
       DSN4 = 0.d0
       !$OMP PARALLEL DO DEFAUlT(SHARED), &
       !$OMP PRIVATE(lx1,lx2,ly1,ly2,s1,s2,y1,s3), &
       !$OMP PRIVATE(DSN1,DSN2,DSN3), &
       !$OMP PRIVATE(lengthl1l2,NearIntLength,NearIntl1,NearIntL2), &	 
       !$OMP PRIVATE(B2,sigmaBTT,ell1,l1crossl2,lengthl1,lengthl2)	
       do lx1 = -il, il, Dummyell
          DSN3 = 0.d0
          do ly1 = -il, il, Dummyell
             DSN2 = 0.d0
             do lx2 = -il, il, Dummyell
                DSN1 = 0.d0
                do ly2 = -il, il, Dummyell
                   lengthl1l2 = sqrt(1.d0*(lx1**2+lx2**2+2*lx1*lx2 + ly1**2+ly2**2+2*ly1*ly2))
                   lengthl1 = sqrt(1.d0*(lx1**2+ly1**2))
                   lengthl2 = sqrt(1.d0*(lx2**2+ly2**2))

                   l1crossl2 = lx1*ly2-ly1*lx2
                   NearIntLength =nint(abs(lengthl1l2-lmin)/deltaell)
                   !write(*,*) NearIntLength,  lx1, lx2, ly1, ly2
                   NearIntl1 = nint(abs(lengthl1-lmin)/deltaell)
                   NearIntL2 = nint(abs(lengthl2-lmin)/deltaell)


                   if (NearIntl1 .le. 0) NearIntl1 = 1
                   if (NearIntl2 .le. 0) NearIntl2 = 1
                   if (NearIntLength .le. 0) NearIntLength = 1

                   if(lengthl1 .gt. il .or. lengthl2 .gt. il .or. lengthl1l2 .gt. min(il,ellarrT(llmaxT-1)) .or. &
                        lengthl1 .lt. 10 .or. lengthl2 .lt. 10 .or. lengthl1l2 .lt. 10) then 
                      B2 = 0.0
                      sigmaBTT = 1.0 !needed for OMP
                   else
                      if (do_log_ell) then
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl1,s1)
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl2,s2)
                         call OneDlinear_IrrGrid_interpolation(lmin,llmaxT,ClBB,lengthl1l2,s3)
                      else                           
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl1,lstep,s1)
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl2,lstep,s2)
                         call OneDlinear_interpolation(lmin,llmaxT,ClBB,lengthl1l2,lstep,s3)
                      endif
                      !sigma in case with/without noise (+ cv)
                      if (cosmic_variance) then 
                         !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*s1*s2*(2*pi)**2
                         sigmaBTT = s3*s1*s2*(2*pi)**3
                      else
                         !sigmaTTT = (ClTT(NearIntLength)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                         !     (ClTT(NearIntL2)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))* &
                         !     (ClTT(NearIntl1)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1)))
                         sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*(s1*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1))) &
                              *(s2*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))
                      endif
                      if (do_log_ell) then
                         call ThreeDlinear_IrrGrid_interpolation(lmin,llmaxT,testlmax,blll,lengthl1l2,lengthl2,lengthl1,y1)
                      else
                         call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,blll,lengthl1l2,lengthl2,lengthl1,lstep,y1)
                      endif
                      B2 = y1**2
                      DSN1 = DSN1 + B2/(sigmaBTT)*(Dummyell) !*real(l1crossl2)**2/lengthl1l2**2/lengthl1**2

                      integrand2d(NearIntLength, nearintl2) = integrand2d(NearIntLength, nearintl2) + &
                           B2/(sigmaBTT)*(Dummyell)**4/(4.d0*pi**3)*(4.d0)**2
                   endif

                   !write(*,*) DSN1

                enddo
                DSN2 = DSN2 + DSN1*(Dummyell)

             enddo
             DSN3 = DSN3 + DSN2*(Dummyell)
          enddo
          DSN4 = DSN4 + DSN3*(Dummyell)
          write(*,*) lx1, ly1, lx2, ly2, DSN4,sqrt((4.d0*pi**3)/DSN4)
       enddo
       !$OMP END PARALLEL DO

       open(unit=8,file = '../data/integrand2d_CV_r_0.01_GRID_btt.dat', &
            form='unformatted', status="replace",access='direct', recl = 8 * (lmaxScal/Dummyell) * (lmaxScal/Dummyell))
       write(unit=8,rec=1) integrand2d(:,:) 
       close(unit=8)
       deallocate(integrand2d)

    else 
       open(unit=28,file='../data/SN_BTT2D_Cosmic-Var_GRIDell_USR.txt', status="replace")

       Dummyell = 20
       deltaell = Dummyell
       write(*,'(A40)') "<<<<<<<<<<<< Computing S/N >>>>>>>>>>>>>"
       DSN4 = 0.d0
       !!from Hu: http://journals.aps.org/prd/pdf/10.1103/PhysRevD.62.043007, Eq. C22
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(lx1,lx2,ly1,ly2,s1,s2,s3,y1), &
       !$OMP PRIVATE(DSN1,DSN2,DSN3,DSN4), &
       !$OMP PRIVATE(lengthl1l2,NearIntLength,NearIntl1,NearIntL2), &	
       !$OMP PRIVATE(B2,sigmaBTT,ell1,l1crossl2,lengthl1,lengthl2)	
       do il = 60, 1700, 40
          !write (*, *) 'loop for BTT', il , OMP_GET_THREAD_NUM()
          DSN4 = 0.d0

          do lx1 = -il, il-1, Dummyell
             DSN3 = 0.d0
             do ly1 = -il , il-1, Dummyell
                DSN2 = 0.d0
                do lx2 = -il, il-1, Dummyell
                   DSN1 = 0.d0
                   do ly2 = -il, il-1, Dummyell

                      !very approximate for now:
                      lengthl1l2 = sqrt(1.d0*(lx1**2+lx2**2+2*lx1*lx2 + ly1**2+ly2**2+2*ly1*ly2))
                      lengthl1 = sqrt(1.d0*(lx1**2+ly1**2))
                      lengthl2 = sqrt(1.d0*(lx2**2+ly2**2))

                      l1crossl2 = lx1*ly2-ly1*lx2
                      NearIntLength =nint(abs(lengthl1l2-lmin)/deltaell)
                      !write(*,*) NearIntLength,  lx1, lx2, ly1, ly2
                      NearIntl1 = nint(abs(lengthl1-lmin)/deltaell)
                      NearIntL2 = nint(abs(lengthl2-lmin)/deltaell)


                      if (NearIntl1 .le. 0) NearIntl1 = 1
                      if (NearIntl2 .le. 0) NearIntl2 = 1
                      if (NearIntLength .le. 0) NearIntLength = 1

                      if(lengthl1 .gt. il .or. lengthl2 .gt. il .or. lengthl1l2 .gt. min(il,ellarrT(llmaxT-1)) .or. &
                           lengthl1 .lt. 10 .or. lengthl2 .lt. 10 .or. lengthl1l2 .lt. 10) then 
                         B2 = 0.0
                         sigmaBTT = 1.0 !needed for OMP
                      else
                         if (do_log_ell) then
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,CLTT,lengthl1,s1)
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,CLTT,lengthl2,s2)
                            !write(*,*) lengthl1l2
                            call OneDlinear_IrrGrid_interpolation(lmin,llmaxT,CLBB,lengthl1l2,s3)
                         else                           
                            call OneDlinear_interpolation(lmin,testlmax,CLTT,lengthl1,lstep,s1)
                            call OneDlinear_interpolation(lmin,testlmax,CLTT,lengthl2,lstep,s2)
                            call OneDlinear_interpolation(lmin,llmaxT,CLBB,lengthl1l2,lstep,s3)
                         endif
                         !sigma in case with/without noise (+ cv)
                         if (cosmic_variance) then 
                            !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*s1*s2*(2*pi)**2
                            sigmaBTT = s3*s1*s2*(2*pi)**3
                         else
                            !sigmaTTT = (ClTT(NearIntLength)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                            !     (ClTT(NearIntL2)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))* &
                            !     (ClTT(NearIntl1)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1)))
                            !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*(s1*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1))) &
                             !    *(s2*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))
                             sigmaBTT = (s3*2d0*pi + Noise_l(1d0, sqrt(2d0), int(lengthl1l2))) &
				   *(s1*(2d0*pi) + Noise_l(1d0, 1d0, int(lengthl1)))&
				   *(s2*(pi*2d0) + Noise_l(1d0, 1d0, int(lengthl2)))  
			endif
                         if (do_log_ell) then
                            call ThreeDlinear_IrrGrid_interpolation(lmin,llmaxT,testlmax,Blll,lengthl1l2,lengthl2,lengthl1,y1)
                         else
                            call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,Blll,lengthl1l2,lengthl2,lengthl1,lstep,y1)
                         endif

                         B2 = y1**2
                         !write(*,*) s2, Noise_l(1d0, 1d0, int(lengthl2))
			 DSN1 = DSN1 + B2/(sigmaBTT)*(Dummyell) !*real(l1crossl2)**2/lengthl1l2**2/lengthl1**2
                      endif
                   enddo
                   DSN2 = DSN2 + DSN1*(Dummyell)
                enddo
                DSN3 = DSN3 + DSN2*(Dummyell)
             enddo
             DSN4 = DSN4 + DSN3*(Dummyell)
          enddo
          DSN4 = DSN4/(4.d0*pi**3)
          NearIntl1 = int(abs(lengthl1-10)/deltaell)
          if (NearIntl1 .le. 0) NearIntl1 = 1
          ell1 = ellarrS(NearIntl1)
          write(28,*) lx1, DSN4, 4.d0*sqrt(1.d0/DSN4)
          write(*,*) lx1, sqrt(DSN4), 4.d0*sqrt(1.d0/DSN4)
       enddo
       !$OMP END PARALLEL DO 
       close(28)
    endif

    deallocate(Blll)
    if (want3D) deallocate(w3j)



  end subroutine Get_SN_BTT


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!BEE-SN!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Get_SN_BEE(testlmax)

    integer  :: testlmax
    integer  :: lx1, ly1, lx2, ly2, l1crossl2, il, l1, l2, l3, ilmax
    integer  :: lx1i, lx2i, ly1i, ly2i
    integer  :: NearIntLength, NearIntl1, NearIntL2
    real(dl) :: lengthl1l2, lengthl1, lengthl2
    real(dl) :: DSN3, DSN4, DSN1, DSN2
    real(dl)    :: Bnoise(5000), Enoise(5000), sigmaBEE, sigmaBEE2
    character(120) :: B_BEEfile, SNfile, NoiseDataB, NoiseDataE
    real(dl),allocatable:: Blll(:,:,:)
    integer :: j,i,s,w, ell1, ell2, ell3
    real(dl) :: Rell, B2
    integer :: deltaell
    integer :: ellarrPolScal(2500)
    integer :: ellarrT(2500) 
    integer :: Dummyell
    real(dl)  :: a3j(0:10000)
    real(dl) :: y1, y2, s1, s2, s3
    real(dl), allocatable  :: integrand2d(:, :)
    real(dl), allocatable  :: integrand3d(:, :)
    real(dl), allocatable  :: w3j(:,:,:)
    logical :: want_integrand
    logical :: cosmic_variance, PrimTens
    logical :: want3D
    logical :: want_SN_3D_lmin
    logical :: BeamNoiseGrid
    integer :: resboost  = 1
    integer :: DownSamp
    real(dl) :: testell
    integer :: llmaxT, ilTmax
    real(dl) :: beam = 0
    integer ::  beamsteps = 10, noisesteps
    real(dl) :: w0T = 1.d0
    real(dl) :: w0B = sqrt(2.d0)
    real(dl) :: fsky

    cosmic_variance  = .true.
    PrimTens = .true.
    BeamNoiseGrid  = .false.
    TtoS = 0.01
    want_integrand = .false. 
    scalars  = .true. 
    polarization = .true.
    want3D = .false.
    want_SN_3D_lmin = .false.
    !for now we can only do this. 
    AppLSS = .true.

    call Compute_CL_flat
    !it determines lmax from the Cl's 
    if (testlmax .eq. 0) testlmax = public_intlmaxS

    !DownSamp = 5
    !testlmax = int(256/DownSamp)
    llmaxT =  public_intlmaxPolTens!int(256/DownSamp)
    write(*,*) testlmax, llmaxT

    !testing linear interpolation
    open(unit=28,file='testcl.txt', status="replace")
!!$    do i = 1, 4500
!!$       testell = i + 10
!!$       call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,testell,s1)
!!$       write(28,*) testell, s1
!!$    enddo
!!$    close(28)
!!$    stop

    !for now, not pretty. 
    deltaell  = lstep
    if (AppLss) then 
       B_BEEfile = Trim(homefolder)//Trim(rootnameBl)//trim('_BEE_USRfull2.txt')
       SNfile = Trim(homefolder)//Trim(rootnameBl)//trim('BEE_SN.txt')
       NoiseDataB = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_CMB-S4.txt')
       NoiseDataE = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_E_CMB-S4.txt')
       !other experiments:

       !noise_B_Planck.txt
       !noise_T_Planck.txt

       !noise_N_spider.txt

       !noise_T_SPTpol.txt
       !noise_B_Bicep-Keck.txt
       !NoiseData = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_Bicep-Keck.txt')

    else
       B_BEEfile = Trim(homefolder)//Trim(rootnameBl)//trim('_Blll_BEEb.txt')
       SNfile = Trim(homefolder)//Trim(rootnameBl)//trim('BEE_SN.txt')
       ! NoiseData = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_CMB-S4.txt')
       NoiseDataB = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_B_Bicep-Keck.txt')


    endif
    !B_BTTfile = 'BTT_equil_sorted.txt'
    allocate(Blll(llmaxT,testlmax,testlmax))
    Blll = 0.0

    open(unit=28,file=B_BEEfile, status="old")
    write(*,'(A40)') "<<<<<<<<<<<< Reading B-file >>>>>>>>>>>>"
    do j = 1, testlmax !loop over ells
       !ell1 = ellarrPolScal(j)
       !write(*,*) ell1
       do i = j, testlmax !only for i .ge. j
          !ell2 = ellarrPolScal(i)
          do s = 1, llmaxT !should do all ell   
             !ell3 = ellarrT(s)
             !read(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             read(28,*) ell1, ell2, ell3, Blll(s,i,j)
             !write(*,*) ell1, ell2, ell3, Blll(s,i,j)
             !association. Needed for S/N. 

             Blll(s,j,i) = -Blll(s,i,j) !or "+", does not matter since it is squared
             ellarrT(s) = ell3
          enddo
       enddo
       ellarrPolScal(j) = ell1
       !write(*,*) ell1
    enddo
    close(28)
    !stop
!!$    open(unit=8,file = '../data/BTT_3d.dat', &
!!$         form='unformatted', access='direct', recl = 8 * testlmax * testlmax * lmaxT)
!!$    write(unit=8,rec=1) Blll(:,:,:) 
!!$    close(unit=8)

   ! open(unit=28,file=NoiseDataB , status="old")
   ! do i  = 1, 4500
   !    read(28,*) Rell, Bnoise(i) !in muK^2, i = 1 -> ell  = 2
   ! enddo
   ! close(28)
   ! open(unit=28,file=NoiseDataT , status="old")
   ! do i  = 1,4800
   !    read(28,*) Rell, Tnoise(i) !in muK^2, i = 1 -> ell  = 2
   ! enddo
   ! close(28)
!commented out hwinch august 6


    if (want3D .or. BeamNoiseGrid) then 
       allocate(w3j(2*testlmax+1,2*testlmax+1,2*testlmax+1))
       do j = 1, testlmax
          ell1 = ellarrPolScal(j)
          do i = j, testlmax
             ell2 = ellarrPolScal(i)
             call GetThreeJs(a3j((abs(ell2-ell1)):(ell2+ell1)),ell1, ell2,0,0)
             do s = i, i+j !is tis all?
                ell3 = ellarrT(s)
                if(ellarrPolScal(s) .gt. ell1+ell2) exit
                !store wigner 3j:

                w3j(s,i,j) = a3j(ell3)
                w3j(s,j,i) = w3j(s,i,j)
                w3j(i,s,j) = w3j(s,i,j)
                w3j(j,i,s) = w3j(s,i,j)
                w3j(i,j,s) = w3j(s,i,j)
                w3j(j,s,i) = w3j(s,i,j)

             enddo
          enddo
       enddo
    endif



    if (want3D) then

       open(unit=28,file='../data/SN_BEE3D_CMBS4xCMBS4_equil_r_1.0.txt', status="replace")
       if (resboost .ne. 1) then
          ilmax  = (testlmax-1)*resboost
          ilTmax = (llmaxT-1)*resboost
          deltaell = deltaell/resboost
          write(*,*) ilmax, deltaell
       else
          ilmax = testlmax
          ilTmax = llmaxT
       endif
       allocate(integrand3d(ilTmax, ilmax))
       integrand3d = 0.0
       do il = 5*resboost, ilmax, 5*resboost
          !il = ilmax
          DSN3 = 0.0d0
          !il = ilmax
          do s = 1, ilTmax, 1 !loop over ells
             if (resboost .ne. 1) then
                ell1 = lmin + (s-1)*deltaell
             else            
                ell1 = ellarrPolScal(s)
                !write(*,*) ell1
             endif
             DSN2 = 0.0d0
             do j = 1, il, 1 !only for i .ge. j
                if (resboost .ne. 1) then
                   ell2 = lmin + (j-1)*deltaell
                else            
                   ell2 = ellarrPolScal(j)
                endif
                DSN1 = 0.0d0
                do i = j, il, 1 
                   if (resboost .ne. 1) then
                      ell3 = lmin + (i-1)*deltaell
                      call OneDlinear_interpolation(lmin,testlmax,CLEE,real(ell1,8),lstep,s1)
                      call OneDlinear_interpolation(lmin,testlmax,CLEE,real(ell2,8),lstep,s2)
                      call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,Blll, &
                           real(ell1,8),real(ell2,8),real(ell3,8),lstep,y1)
                   else            
                      ell3 = ellarrT(i)
                      s1 = CLEE(j)
                      s2 = CLEE(i)
                      s3 = ClBB(s)
                      y1 = Blll(s,i,j)
                   endif

                   B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                   !B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                   !*((4*pi)**2*sqrt(2.)/2.)**2 
                   !write(*,*) LargeArg3Js(ell1,ell2,ell3)**2


                   !if(cosmic_variance) then 
                   !   sigmaBEE = s1*s2*Bnoise(ellarrPolScal(s)-9)*(2*pi)**2 &
                   !        *DeltaBis(ell2,ell3,ell1)
                   !elseif(PrimTens) then 
                   !   sigmaBEE = (Bnoise(ellarrPolScal(s)-9)+s3*(2*pi))* &
                   !        (Enoise(ellarrPolScal(i)-9)+s2*(2*pi))* &
                   !        (Enoise(ellarrPolScal(j)-9)+s1*(2*pi))* &
                   !        DeltaBis(ell2,ell3,ell1)                 
                   !else                   
                   sigmaBEE = Noise_l(1d0, sqrt(2d0), ell3)* &
				  (s1*(2d0*pi) + Noise_l(1d0, sqrt(2d0), ell1))* &
				  (s2*(pi*2d0) + Noise_l(1d0, sqrt(2d0), ell2))  
                   !endif
                   DSN1 = DSN1 + Blll(s,i,j)/(sigmaBEE)*(ellarrT(i+1)-ellarrT(i))
                   !DSN1 = DSN1 + B2/(sigmaTTT)*(deltaell)
                   !write(*,*) 'DSN1:',DSN1
                   !if (il .eq. ) then
                   integrand3d(s,j) = integrand3d(s,j) + B2/(sigmaBEE)*(deltaell)**3
                   !write(*,*) integrand3d(s,j)
                   !endif
                enddo
                DSN2 = DSN2 + DSN1*(ellarrPolScal(j+1)-ellarrPolScal(j))

             enddo
             DSN3 = DSN3 + DSN2*(ellarrPolScal(s+1)-ellarrPolScal(s))
          enddo
          !the factor 4 comes from the tranfer functions. This needs to be fixed. 
          write(28,*) ell2, 4.0*sqrt(1.d0/DSN3/2.0)
          write(*,*) ell2, 4.0*sqrt(1.d0/DSN3/2.0)
       enddo
       close(28)

!!$    do i = 1, ilmax
!!$       do j = 1, ilmax
!!$          write(*,*) i,j,integrand3d(i,j)
!!$       enddo
!!$    enddo
       open(unit=8,file = '../data/integrand3d_deltaell_4_BICEPxSPT_btt.dat', &
            form='unformatted', status="replace", access='direct', recl = 8 * (ilmax) * (ilTmax))
       write(unit=8,rec=1) integrand3d(:,:) 
       close(unit=8)
       deallocate(integrand3d)
    endif
    !for testing:
!!$    do i = 1, 5000
!!$       write(*,*) i, Noise_l(1.d0, 1.d0,i)
!!$    enddo 
    if(BeamNoiseGrid) then
       open(unit=28,file='../data/SN_BEE3D_planckxplanck_beam_fsky_equil_r_0.01.txt', status="replace")
       beam = 0
       beamsteps = 5!46
       noisesteps = 5!46
       w0T = 0.8d0
       w0B = sqrt(2.d0)
       fsky = 0.7
       ilmax = 256
       ilTmax = 131
       do w = 1, noisesteps
          beam = 4.d0 !0.8d0
          fsky = fsky + 0.01
          !number below is determined from
          !having s = 1 for fsky =  0.4
          !w0T = 1.58114*sqrt(fsky)
          !for Planck
          !having s = 30 for fsky =  1.0
          w0T = 30.d0*sqrt(fsky)
          !w0T = w0T +  0.2d0
          !w0B = sqrt(2.d0)*w0T
          
          !for planck
          w0B = 2.d0*w0T
	  do il = 1, beamsteps

             !set beam (defaul for CMB-S4 is 1-10)
             beam = beam + 0.2d0

             !il = ilmax
             DSN3 = 0.0d0
             !il = ilmax
             do s = 21, ilTmax, 1 !lmin  = 30
                ell1 = ellarrPolScal(s)
                DSN2 = 0.0d0
                do j = 21, ilmax, 1 !only for i .ge. j
                   ell2 = ellarrPolScal(j)
                   DSN1 = 0.0d0
                   do i = j, ilmax, 1 

                      ell3 = ellarrPolScal(i)
                      s1 = CLEE(j)
                      s2 = CLEE(i)
                      s3 = ClBB(s)
                      y1 = Blll(s,i,j)

                      B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                      !B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                      !*((4*pi)**2*sqrt(2.)/2.)**2 
                      !write(*,*) LargeArg3Js(ell1,ell2,ell3)**2


                      if(cosmic_variance) then 
                         sigmaBEE = s1*s2*Noise_l(beam,w0B,ell1)*(2*pi)**2 &
                              *DeltaBis(ell2,ell3,ell1)
                      elseif(PrimTens) then 
                         sigmaBEE = (Noise_l(beam,w0B,ell1)+s3*(2*pi))* &
                              (Noise_l(beam,w0T,ell3)+s2*(2*pi))* &
                              (Noise_l(beam,w0T,ell2)+s1*(2*pi))* &
                              DeltaBis(ell2,ell3,ell1)                 
                      else                   
                         sigmaBEE = (Noise_l(beam,w0B,ell1))* &
                              (Noise_l(beam,w0T,ell3)+s2*(2*pi))* &
                              (Noise_l(beam,w0T,ell2)+s1*(2*pi))* &
                              DeltaBis(ell2,ell3,ell1)
                      endif
                      DSN1 = DSN1 + y1**2/(sigmaBEE)*(ellarrPolScal(i+1)-ellarrPolScal(i))

                   enddo
                   DSN2 = DSN2 + DSN1*(ellarrPolScal(j+1)-ellarrPolScal(j))

                enddo
                DSN3 = DSN3 + DSN2*(ellarrPolScal(s+1)-ellarrPolScal(s))
             enddo
          !the factor 4 comes from the tranfer functions. This needs to be fixed. 
          write(28,*) fsky, beam, 4.0*sqrt(1.d0/DSN3/2.0)/sqrt(fsky), DSN3
          write(*,*) fsky, beam, 4.0*sqrt(1.d0/DSN3/2.0)/sqrt(fsky), DSN3
          enddo

       enddo
       close(28)

    endif
    
    !stop

    if(want_SN_3D_lmin) then 
       open(unit=28,file='../data/SN_lmin_BEE3D_CMBS4xCMBS4test2_dell4.txt', status="replace")
       if (resboost .ne. 1) then
          ilmax  = (testlmax-1)*resboost
          ilTmax = (llmaxT-1)*resboost
          !deltaell = deltaell/resboost
          write(*,*) ilmax, deltaell
       else
          ilmax = testlmax
          ilTmax = llmaxT
       endif
       allocate(integrand3d(ilmax, ilmax))
       integrand3d = 0.0
       do il =1, ilTmax, 2*resboost
          !il = testlmax
          DSN3 = 0.0d0
          !il = ilmax
          do s = il, ilTmax, 1 !loop over ells
             if (resboost .ne. 1) then
                ell1 = lmin + (s-1)*deltaell
             else            
                ell1 = ellarrPolScal(s)
             endif
             DSN2 = 0.0d0
             do j = il, ilmax, 1 !only for i .ge. j
                if (resboost .ne. 1) then
                   ell2 = lmin + (j-1)*deltaell
                else            
                   ell2 = ellarrPolScal(j)
                endif
                DSN1 = 0.0d0
                do i = j, ilmax, 1 
                   if (resboost .ne. 1) then
                      ell3 = lmin + (i-1)*deltaell
                      call OneDlinear_interpolation(lmin,testlmax,ClTT,real(ell2,8),lstep,s1)
                      call OneDlinear_interpolation(lmin,testlmax,ClTT,real(ell3,8),lstep,s2)
                      call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,Blll, &
                           real(ell1,8),real(ell2,8),real(ell3,8),lstep,y1)
                   else            
                      ell3 = ellarrPolScal(i)
                      s1 = ClTT(j)
                      s2 = ClTT(i)
                      y1 = Blll(s,i,j)
                   endif

                   !B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                   B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                   !*((4*pi)**2*sqrt(2.)/2.)**2 



                   if(cosmic_variance) then 
                      sigmaBEE = s1*s2*Bnoise(9+int(deltaell)*(s-1))*(2*pi)**2 &
                           *DeltaBis(ell2,ell3,ell1)
                   else
                      !sigmaBEE = (Bnoise(9+int(deltaell)*(s-1)))* &
                      !     (Enoise(9+int(deltaell)*(i-1))+s2*(2*pi))* &
                      !     (Enoise(9+int(deltaell)*(j-1))+s1*(2*pi))
		      sigmaBEE = Noise_l(1d0, sqrt(2d0), int(ell3))* &
			    (s1*(2d0*pi) + Noise_l(1d0, sqrt(2d0), int(ell1)))* &
		  	    (s2*(pi*2d0) + Noise_l(1d0, sqrt(2d0), int(ell2)))
                   endif
                   DSN1 = DSN1 + B2/(sigmaBEE)*(deltaell)
                   !write(*,*) 'DSN1:',DSN1
                   !if (il .eq. ) then
                   !integrand3d(s,j) = integrand3d(s,j) + B2/(sigmaBTT)*(deltaell)**3
                   !write(*,*) integrand3d(s,j)
                   !endif
                enddo
                DSN2 = DSN2 + DSN1*deltaell
                !write(*,*) DSN2
             enddo
             DSN3 = DSN3 + DSN2*deltaell
          enddo
          DSN3 = DSN3 !multiply by multiplicity
          !DSN3 = DSN3
          write(28,*) lmin + (il-1)*deltaell, sqrt(2.0/DSN3)
          write(*,*) lmin + (il-1)*deltaell, sqrt(2.0/DSN3)
       enddo
       close(28)
    endif
    
    !write(*,'(A40)') "I'm here"

    if(want_integrand) then

       Dummyell = 20
       deltaell = Dummyell
       allocate(integrand2d(lmaxScal/Dummyell, lmaxScal/Dummyell))
       integrand2d = 0
       write(*,'(A40)') "<<<<<<<<<<<<   Integrand   >>>>>>>>>>>>>"
       il = 4400
       DSN4 = 0.d0
       !$OMP PARALLEL DO DEFAUlT(SHARED), &
       !$OMP PRIVATE(lx1,lx2,ly1,ly2,s1,s2,y1,s3), &
       !$OMP PRIVATE(DSN1,DSN2,DSN3), &
       !$OMP PRIVATE(lengthl1l2,NearIntLength,NearIntl1,NearIntL2), &	 
       !$OMP PRIVATE(B2,sigmaBEE,ell1,l1crossl2,lengthl1,lengthl2)	
       do lx1 = -il, il, Dummyell
          DSN3 = 0.d0
          do ly1 = -il, il, Dummyell
             DSN2 = 0.d0
             do lx2 = -il, il, Dummyell
                DSN1 = 0.d0
                do ly2 = -il, il, Dummyell
                   lengthl1l2 = sqrt(1.d0*(lx1**2+lx2**2+2*lx1*lx2 + ly1**2+ly2**2+2*ly1*ly2))
                   lengthl1 = sqrt(1.d0*(lx1**2+ly1**2))
                   lengthl2 = sqrt(1.d0*(lx2**2+ly2**2))

                   l1crossl2 = lx1*ly2-ly1*lx2
                   NearIntLength =nint(abs(lengthl1l2-lmin)/deltaell)
                   !write(*,*) NearIntLength,  lx1, lx2, ly1, ly2
                   NearIntl1 = nint(abs(lengthl1-lmin)/deltaell)
                   NearIntL2 = nint(abs(lengthl2-lmin)/deltaell)


                   if (NearIntl1 .le. 0) NearIntl1 = 1
                   if (NearIntl2 .le. 0) NearIntl2 = 1
                   if (NearIntLength .le. 0) NearIntLength = 1

                   if(lengthl1 .gt. il .or. lengthl2 .gt. il .or. lengthl1l2 .gt. min(il,ellarrT(llmaxT-1)) .or. &
                        lengthl1 .lt. 30 .or. lengthl2 .lt. 30 .or. lengthl1l2 .lt. 30) then 
                      B2 = 0.0
                      sigmaBEE = 1.0 !needed for OMP
                   else
                      if (do_log_ell) then
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl1,s1)
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl2,s2)
                         call OneDlinear_IrrGrid_interpolation(lmin,llmaxT,ClBB,lengthl1l2,s3)
                      else                           
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl1,lstep,s1)
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl2,lstep,s2)
                         call OneDlinear_interpolation(lmin,llmaxT,ClBB,lengthl1l2,lstep,s3)
                      endif
                      !sigma in case with/without noise (+ cv)
                      if (cosmic_variance) then 
                         !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*s1*s2*(2*pi)**2
                         sigmaBEE = s3*s1*s2*(2*pi)**3
                      else
                         !sigmaTTT = (ClTT(NearIntLength)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                         !     (ClTT(NearIntL2)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))* &
                         !     (ClTT(NearIntl1)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1)))
                         sigmaBEE = Bnoise(9+int(deltaell)*(NearIntLength-1))*(s1*(2*pi)+Enoise(9+int(deltaell)*(NearIntL1-1))) &
                              *(s2*(2*pi)+Enoise(9+int(deltaell)*(NearIntL2-1)))
                      endif
                      if (do_log_ell) then
                         call ThreeDlinear_IrrGrid_interpolation(lmin,llmaxT,testlmax,blll,lengthl1l2,lengthl2,lengthl1,y1)
                      else
                         call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,blll,lengthl1l2,lengthl2,lengthl1,lstep,y1)
                      endif
                      B2 = y1**2
                      DSN1 = DSN1 + B2/(sigmaBEE)*(Dummyell) !*real(l1crossl2)**2/lengthl1l2**2/lengthl1**2

                      integrand2d(NearIntLength, nearintl2) = integrand2d(NearIntLength, nearintl2) + &
                           B2/(sigmaBEE)*(Dummyell)**4/(4.d0*pi**3)*(4.d0)**2
                   endif

                   !write(*,*) DSN1

                enddo
                DSN2 = DSN2 + DSN1*(Dummyell)

             enddo
             DSN3 = DSN3 + DSN2*(Dummyell)
          enddo
          DSN4 = DSN4 + DSN3*(Dummyell)
          write(*,*) lx1, ly1, lx2, ly2, DSN4,sqrt((4.d0*pi**3)/DSN4)
       enddo
       !$OMP END PARALLEL DO

       open(unit=8,file = '../data/integrand2d_CV_r_0.01_GRID_btt.dat', &
            form='unformatted', status="replace",access='direct', recl = 8 * (lmaxScal/Dummyell) * (lmaxScal/Dummyell))
       write(unit=8,rec=1) integrand2d(:,:) 
       close(unit=8)
       deallocate(integrand2d)

    else 
       open(unit=28,file='../data/SN_BEE2D_Cosmic-Var_GRIDell_USR2.txt', status="replace")

       Dummyell = 20
       deltaell = Dummyell
       write(*,'(A40)') "<<<<<<<<<<<< Computing S/N >>>>>>>>>>>>>"
	!write (*,*) CLEE(:)
       DSN4 = 0.d0
	!write (*,*) ellarrT(llmaxT-1)
       !!from Hu: http://journals.aps.org/prd/pdf/10.1103/PhysRevD.62.043007, Eq. C22
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(lx1,lx2,ly1,ly2,s1,s2,s3,y1), &
       !$OMP PRIVATE(DSN1,DSN2,DSN3,DSN4), &
       !$OMP PRIVATE(lengthl1l2,NearIntLength,NearIntl1,NearIntL2), &	
       !$OMP PRIVATE(B2,sigmaBEE,ell1,l1crossl2,lengthl1,lengthl2)	
       do il = 60, 1700, 40
          !write (*, *) 'loop for BTT', il , OMP_GET_THREAD_NUM()
          DSN4 = 0.d0

          do lx1 = -il, il-1, Dummyell
             DSN3 = 0.d0
             do ly1 = -il , il-1, Dummyell
                DSN2 = 0.d0
                do lx2 = -il, il-1, Dummyell
                   DSN1 = 0.d0
                   do ly2 = -il, il-1, Dummyell

                      !very approximate for now:
                      lengthl1l2 = sqrt(1.d0*(lx1**2+lx2**2+2*lx1*lx2 + ly1**2+ly2**2+2*ly1*ly2))
                      lengthl1 = sqrt(1.d0*(lx1**2+ly1**2))
                      lengthl2 = sqrt(1.d0*(lx2**2+ly2**2))

                      l1crossl2 = lx1*ly2-ly1*lx2
                      NearIntLength =nint(abs(lengthl1l2-lmin)/deltaell)
                      !write(*,*) NearIntLength,  lx1, lx2, ly1, ly2
                      NearIntl1 = nint(abs(lengthl1-lmin)/deltaell)
                      NearIntL2 = nint(abs(lengthl2-lmin)/deltaell)


                      if (NearIntl1 .le. 0) NearIntl1 = 1
                      if (NearIntl2 .le. 0) NearIntl2 = 1
                      if (NearIntLength .le. 0) NearIntLength = 1

                      if(lengthl1 .gt. il .or. lengthl2 .gt. il .or. lengthl1l2 .gt. min(il,ellarrT(llmaxT-1)) .or. &
                           lengthl1 .lt. 30 .or. lengthl2 .lt. 30 .or. lengthl1l2 .lt. 30) then 
                         B2 = 0.0
                         sigmaBEE = 1.0 !needed for OMP
                      else
                         if (do_log_ell) then
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,CLEE,lengthl1,s1)
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,CLEE,lengthl2,s2)
                            !write(*,*) lengthl1l2
                            call OneDlinear_IrrGrid_interpolation(lmin,llmaxT,CLBB,lengthl1l2,s3)
                         else                           
                            call OneDlinear_interpolation(lmin,testlmax,CLEE,lengthl1,lstep,s1)
                            call OneDlinear_interpolation(lmin,testlmax,CLEE,lengthl2,lstep,s2)
                            call OneDlinear_interpolation(lmin,llmaxT,CLBB,lengthl1l2,lstep,s3)
                         endif
                         !sigma in case with/without noise (+ cv)
                         if (cosmic_variance) then 
                            !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*s1*s2*(2*pi)**2
                            sigmaBEE = s3*s1*s2*(2d0*pi)**3
                         else
                            !sigmaTTT = (ClTT(NearIntLength)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                            !     (ClTT(NearIntL2)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))* &
                            !     (ClTT(NearIntl1)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1)))
                            !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*(s1*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1))) &
                             !    *(s2*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))
                             sigmaBEE = (s3*2d0*pi + Noise_l(1d0, sqrt(2d0), int(lengthl1l2)))* &
				  (s1*(2d0*pi) + Noise_l(1d0, sqrt(2d0), int(lengthl1)))* &
				  (s2*(pi*2d0) + Noise_l(1d0, sqrt(2d0), int(lengthl2)))  
			endif
                         if (do_log_ell) then
                            call ThreeDlinear_IrrGrid_interpolation(lmin,llmaxT,testlmax,Blll,lengthl1l2,lengthl2,lengthl1,y1)
                         else
                            call ThreeDlinear_interpolation(lmin,llmaxT,testlmax,Blll,lengthl1l2,lengthl2,lengthl1,lstep,y1)
                         endif

                         B2 = y1**2
                         DSN1 = DSN1 + B2/(sigmaBEE)*(Dummyell) !*real(l1crossl2)**2/lengthl1l2**2/lengthl1**2
			 !write(*,*) s1, Noise_l(1d0, sqrt(2d0), int(lengthl1)), s2, Noise_l(1d0, sqrt(2d0), int(lengthl2))
			 !if (lengthl2 .gt. 500) write (*,*) s1, CLEE(int(lengthl2))
                      endif
                   enddo
                   DSN2 = DSN2 + DSN1*(Dummyell)
                enddo
                DSN3 = DSN3 + DSN2*(Dummyell)
             enddo
             DSN4 = DSN4 + DSN3*(Dummyell)
          enddo
          DSN4 = DSN4/(4.d0*pi**3)
          NearIntl1 = int(abs(lengthl1-10)/deltaell)
          if (NearIntl1 .le. 0) NearIntl1 = 1
          ell1 = ellarrPolScal(NearIntl1)
          write(28,*) lx1, DSN4, 4.d0*sqrt(1.d0/DSN4)
          write(*,*) lx1, sqrt(DSN4), 4.d0*sqrt(1.d0/DSN4)
       enddo
       !$OMP END PARALLEL DO 
       close(28)
    endif

    deallocate(Blll)
    if (want3D) deallocate(w3j)



  end subroutine Get_SN_BEE




  subroutine Get_SN_TTT(testlmax)

    integer  :: testlmax, ilmax
    integer  :: lx1, ly1, lx2, ly2, l1crossl2, il, l1, l2, l3
    integer  :: lx1i, lx2i, ly1i, ly2i
    integer  :: NearIntLength, NearIntl1, NearIntL2
    real(dl) :: lengthl1l2, lengthl1, lengthl2
    real(dl) :: DSN3, DSN4, DSN1, DSN2
    real(dl) :: Tnoise(5000), sigmaTTT, sigmaTTT2
    character(120) :: B_TTTfile, SNfile, NoiseDataT
    real(dl) , allocatable:: Blll(:,:,:)
    integer :: j,i,s, ell1, ell2, ell3
    real(dl) :: Rell, B2
    integer :: deltaell
    integer :: ellarrS(2500) 
    integer :: Dummyell
    real(dl) :: a3j(0:12000)
    real(dl), allocatable  :: w3j(:,:,:)    
    logical :: want_integrand, want3d,want_SN_3D_lmin
    logical :: cosmic_variance !want cosmic variance limited?
    real(dl) :: y1, y2, s1, s2, s3
    integer :: count1, count2
    integer :: resboost  = 1

    !van Engelen
    real(dl), allocatable :: integrand2d(:,:)
    real(dl), allocatable :: integrand3d(:,:)

    real(dl), allocatable :: Fullblll(:,:,:)
    real(dl), allocatable :: FullCLTT(:)
    real(dl), allocatable  :: Fullw3j(:,:,:)
    real(dl) :: fullcl(3000)
    !see below
    real(dl) :: DelEll(477)
    integer ::  FullLarray(477)
    
    want_integrand  = .false.
    cosmic_variance  = .true.
    scalars  = .true. 
    want3D = .true.
    want_SN_3D_lmin = .true.
    !for now we can only do this. 
    AppLSS = .true.

    !it determines lmax from the Cl's 

    !DownSamp = 5
    !testlmax = int(256/DownSamp)
    
    call Compute_CL_flat
    if (testlmax .eq. 0) testlmax = public_intlmaxS

    !to make sure I have the correct value 
    write(*,*) testlmax
    !for now, not pretty. 
    deltaell  = lstep
    if (AppLss) then 
       B_TTTfile = Trim(homefolder)//Trim(rootnameBl)//trim('_Blll_TTT.txt')
       SNfile = Trim(homefolder)//Trim(rootnameBl)//trim('TTT_SN.txt')
       NoiseDataT = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_T_SPTpol.txt')
       !other options:
       !noise_T_SPTpol.txt
       !noise_B_CMB-S4.txt
    else
       B_TTTfile = Trim(homefolder)//Trim(rootnameBl)//trim('_Blll_TTTb.txt')
       SNfile = Trim(homefolder)//Trim(rootnameBl)//trim('TTT_SN.txt')
       NoiseDataT = Trim(homefolder)//Trim(Noise_folder)//Trim('noise_T_CMB-S4.txt')
    endif

    allocate(Blll(testlmax,testlmax,testlmax))
    Blll = 0.0

    open(unit=28,file=B_TTTfile, status="old")
    write(*,'(A40)') "<<<<<<<<<<<< Reading B-file >>>>>>>>>>>>"
    do j = 1, testlmax !loop over ells

       !write(*,*) ell1
       do i = j, testlmax !only for i .ge. j

          do s = i, testlmax !should do all ell   
             read(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             !write(*,*) ell1, ell2, ell3, Blll(s,i,j)
             !association. Needed for S/N. 

             Blll(s,j,i) = Blll(s,i,j)
             Blll(i,s,j) = Blll(s,i,j)
             Blll(j,i,s) = Blll(s,i,j)
             Blll(i,j,s) = Blll(s,i,j)
             Blll(j,s,i) = Blll(s,i,j)

             !if(i .eq. j .and. j .eq. s) write(*,*) ell1, ell2, ell3, Blll(s,i,j), ClTT(i)

          enddo
       enddo
       ellarrS(j) = ell1
       !write(*,*) ell1
    enddo

    close(28)

    open(unit=28,file=NoiseDataT , status="old")
    do i  = 1,4800
       read(28,*) Rell, Tnoise(i) !in muK^2, i = 1 -> ell  = 2
    enddo
    close(28)
    if (want3D) then 
       allocate(w3j(2*testlmax+1,2*testlmax+1,2*testlmax+1))
       do j = 1, testlmax
          ell1 = ellarrS(j)
          do i = j, testlmax
             ell2 = ellarrS(i)
             call GetThreeJs(a3j((abs(ell2-ell1)):(ell2+ell1)),ell1, ell2,0,0)
             do s = i, i+j !is tis all?
                ell3 = ellarrS(s)
                if(ellarrS(s) .gt. ell1+ell2) exit
                !store wigner 3j:

                w3j(s,i,j) = a3j(ell3)
                w3j(s,j,i) = w3j(s,i,j)
                w3j(i,s,j) = w3j(s,i,j)
                w3j(j,i,s) = w3j(s,i,j)
                w3j(i,j,s) = w3j(s,i,j)
                w3j(j,s,i) = w3j(s,i,j)

             enddo
          enddo
       enddo



       write(*,*) resboost
       open(unit=28,file='../data/SN_TTT3D_CMBS4xCMBS4_flat.txt', status="replace")
       if (resboost .ne. 1) then
          ilmax  = (testlmax-1)*resboost
          deltaell = deltaell/resboost
          write(*,*) ilmax, deltaell
       else
          ilmax = testlmax
       endif
       allocate(integrand3d(ilmax, ilmax))
       integrand3d = 0.0
       do il = 5*resboost, ilmax, 5*resboost
       !il = ilmax
       DSN3 = 0.0d0
       !il = ilmax
       do s = 1, il-1, 1 !loop over ells
          if (resboost .ne. 1) then
             ell1 = lmin + (s-1)*deltaell
          else            
             ell1 = ellarrS(s)
          endif
          DSN2 = 0.0d0
          do j = s, il-1, 1 !only for j .ge. s
             if (resboost .ne. 1) then
                ell2 = lmin + (j-1)*deltaell
             else            
                ell2 = ellarrS(j)
             endif
             DSN1 = 0.0d0
             do i = j, il-1, 1 
                if (resboost .ne. 1) then
                   ell3 = lmin + (i-1)*deltaell
                   !call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,real(ell2,8),s1)
                   !call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,real(ell3,8),s2)
                   !call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,real(ell1,8),s3)

                   !call ThreeDlinear_IrrGrid_interpolation(lmin,testlmax,testlmax,Blll, &
                   !     real(ell1,8),real(ell2,8),real(ell3,8),y1)
                else            
                   ell3 = ellarrS(i)
                   s1 = ClTT(j)
                   s2 = ClTT(i)
                   s3 = ClTT(s)
                   y1 = Blll(s,i,j)
                   !write(*,*) y1
                endif

                B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                !B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                !*((4*pi)**2*sqrt(2.)/2.)**2 



                if(cosmic_variance) then 
                   sigmaTTT = s1*s2*s3*(2*pi)**3 &
                        *DeltaBisFS(ell2,ell3,ell1)
                   !write(*,*) sigmaTTT
                else
                   sigmaTTT = (Tnoise(9+int(deltaell)*(s-1))+s3*(2*pi))* &
                        (Tnoise(9+int(deltaell)*(i-1))+s2*(2*pi))* &
                        (Tnoise(9+int(deltaell)*(j-1))+s1*(2*pi))* &
                        DeltaBisFS(ell2,ell3,ell1)

                endif

                DSN1 = DSN1 + B2/(sigmaTTT)*(ellarrS(i+1)-ellarrS(i))
                !DSN1 = DSN1 + B2/(sigmaTTT)*(deltaell)
                !write(*,*) 'DSN1:',DSN1
                !if (il .eq. ) then
                integrand3d(s,j) = integrand3d(s,j) + B2/(sigmaTTT)*(deltaell)**3
                !write(*,*) integrand3d(s,j)
                !endif
             enddo
             DSN2 = DSN2 + DSN1*(ellarrS(j+1)-ellarrS(j))
 
          enddo
          DSN3 = DSN3 + DSN2*(ellarrS(s+1)-ellarrS(s))
       enddo
       !not sure about the facto of 6. I think it should be there
       write(28,*) ell1, sqrt(1.d0/DSN3/6.0/((2.d0*pi)**2))
       write(*,*) ell1, sqrt(1.d0/DSN3/6.0/((2.d0*pi)**2))
       enddo
       close(28)

       open(unit=8,file = '../data/integrand3d_deltaell_4_BICEPxSPT_ttt.dat', &
            form='unformatted', status="replace", access='direct', recl = 8 * (ilmax) * (ilmax))
       write(unit=8,rec=1) integrand3d(:,:) 
       close(unit=8)
       deallocate(integrand3d)
    endif

    if(want_SN_3D_lmin) then 
       open(unit=28,file='../data/SN_lmin_TTT3D_CMBS4xCMBS4_flat.txt', status="replace")
       if (resboost .ne. 1) then
          ilmax  = (testlmax-1)*resboost
          !deltaell = deltaell/resboost
          write(*,*) ilmax, deltaell
       else
          ilmax = testlmax
       endif
       allocate(integrand3d(ilmax, ilmax))
       integrand3d = 0.0
       do il =1, ilmax-1, 2*resboost
          !il = testlmax
          DSN3 = 0.0d0
          !il = ilmax
          do s = il, ilmax-1, 1 !loop over ells
             if (resboost .ne. 1) then
                ell1 = lmin + (s-1)*deltaell
             else            
                ell1 = ellarrS(s)
             endif
             DSN2 = 0.0d0
             do j = s, ilmax-1, 1 !only for i .ge. j
                if (resboost .ne. 1) then
                   ell2 = lmin + (j-1)*deltaell
                else            
                   ell2 = ellarrS(j)
                endif
                DSN1 = 0.0d0
                do i = j, ilmax-1, 1 
                   if (resboost .ne. 1) then
                      ell3 = lmin + (i-1)*deltaell
                      !call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,real(ell2,8),lstep,s1)
                      !call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,real(ell3,8),lstep,s2)
                      !call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,real(ell1,8),lstep,s3)

                      !call ThreeDlinear_IrrGrid_interpolation(lmin,testlmax,testlmax,Blll, &
                           !real(ell1,8),real(ell2,8),real(ell3,8),lstep,y1)
                   else            
                      ell3 = ellarrS(i)
                      s1 = ClTT(j)
                      s2 = ClTT(i)
                      s3 = ClTT(s)

                      y1 = Blll(s,i,j)
                   endif

                   B2 = w3j(s,i,j)**2*Illl(ell1,ell2,ell3)**2*Blll(s,i,j)**2.0d0
                   !B2 =  LargeArg3Js(ell1,ell2,ell3)**2*Illl(ell1,ell2,ell3)**2*y1**2.0d0 !&
                   !*((4*pi)**2*sqrt(2.)/2.)**2 



                   if(cosmic_variance) then 
                      sigmaTTT = s1*s2*s3*(2*pi)**3 &
                           *DeltaBis(ell2,ell3,ell1)
                   else
                      sigmaTTT = (Tnoise(9+int(deltaell)*(j-1))+s1*(2*pi))* &
                           (Tnoise(9+int(deltaell)*(i-1))+s2*(2*pi))* &
                           (Tnoise(9+int(deltaell)*(s-1))+s3*(2*pi))
                   endif
                   DSN1 = DSN1 + B2/(sigmaTTT)*(ellarrS(i+1)-ellarrS(i))
                   !write(*,*) 'DSN1:',DSN1
                   !if (il .eq. ) then
                   !integrand3d(s,j) = integrand3d(s,j) + B2/(sigmaBTT)*(deltaell)**3
                   !write(*,*) integrand3d(s,j)
                   !endif
                enddo
             DSN2 = DSN2 + DSN1*(ellarrS(j+1)-ellarrS(j))
             !DSN2 = DSN2 + DSN1*deltaell
             !write(*,*) DSN2
          enddo
          DSN3 = DSN3 + DSN2*(ellarrS(s+1)-ellarrS(s))
          !DSN3 = DSN3 + DSN2*deltaell
       enddo
       !DSN3 = DSN3
       write(28,*) ellarrS(il), sqrt(1.d0/DSN3/6.0/((2.d0*pi)**2))
       write(*,*) ellarrS(il), sqrt(1.d0/DSN3/6.0/((2.d0*pi)**2))
       enddo
       close(28)
    endif
    stop
    if(want_integrand) then

       Dummyell = 20
       deltaell = Dummyell
       allocate(integrand2d(lmaxScal/Dummyell, lmaxScal/Dummyell))
       integrand2d = 0
       write(*,'(A40)') "<<<<<<<<<<<<   Integrand   >>>>>>>>>>>>>"
       il = 4400
       DSN4 = 0.d0
       !$OMP PARALLEL DO DEFAUlT(SHARED), &
       !$OMP PRIVATE(lx1,lx2,ly1,ly2,s1,s2,y1,s3), &
       !$OMP PRIVATE(DSN1,DSN2,DSN3), &
       !$OMP PRIVATE(lengthl1l2,NearIntLength,NearIntl1,NearIntL2), &	 
       !$OMP PRIVATE(B2,sigmaTTT,ell1,l1crossl2,lengthl1,lengthl2)	
       do lx1 = -il, il, Dummyell
          DSN3 = 0.d0
          do ly1 = -il, il, Dummyell
             DSN2 = 0.d0
             do lx2 = -il, il, Dummyell
                DSN1 = 0.d0
                do ly2 = -il, il, Dummyell
                   lengthl1l2 = sqrt(1.d0*(lx1**2+lx2**2+2*lx1*lx2 + ly1**2+ly2**2+2*ly1*ly2))
                   lengthl1 = sqrt(1.d0*(lx1**2+ly1**2))
                   lengthl2 = sqrt(1.d0*(lx2**2+ly2**2))

                   l1crossl2 = lx1*ly2-ly1*lx2
                   NearIntLength =nint(abs(lengthl1l2-lmin)/deltaell)
                   !write(*,*) NearIntLength,  lx1, lx2, ly1, ly2
                   NearIntl1 = nint(abs(lengthl1-lmin)/deltaell)
                   NearIntL2 = nint(abs(lengthl2-lmin)/deltaell)


                   if (NearIntl1 .le. 0) NearIntl1 = 1
                   if (NearIntl2 .le. 0) NearIntl2 = 1
                   if (NearIntLength .le. 0) NearIntLength = 1

                   if(lengthl1 .gt. il .or. lengthl2 .gt. il .or. lengthl1l2 .gt. il .or. &
                        lengthl1 .lt. 10 .or. lengthl2 .lt. 10 .or. lengthl1l2 .lt. 10) then 
                      B2 = 0.0
                      sigmaTTT = 1.0 !needed for OMP
                   else
                      if (do_log_ell) then
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl1,s1)
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl2,s2)
                         call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl1l2,s3)
                      else                           
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl1,lstep,s1)
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl2,lstep,s2)
                         call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl1l2,lstep,s3)
                      endif
                      !sigma in case with/without noise (+ cv)
                      if (cosmic_variance) then 
                         !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*s1*s2*(2*pi)**2
                         sigmaTTT = s3*s1*s2*(2*pi)**3
                      else
                         !sigmaTTT = (ClTT(NearIntLength)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                         !     (ClTT(NearIntL2)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))* &
                         !     (ClTT(NearIntl1)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1)))
                         sigmaTTT = (s3*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                              (s1*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1))) &
                              *(s2*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))
                      endif
                      if (do_log_ell) then
                         call ThreeDlinear_IrrGrid_interpolation(lmin,testlmax,testlmax,blll,lengthl1l2,lengthl2,lengthl1,y1)
                      else
                         call ThreeDlinear_interpolation(lmin,testlmax,testlmax,blll,lengthl1l2,lengthl2,lengthl1,lstep,y1)
                      endif
                      B2 = y1**2
                      DSN1 = DSN1 + B2/(sigmaTTT)*(Dummyell) !*real(l1crossl2)**2/lengthl1l2**2/lengthl1**2

                      integrand2d(NearIntLength, nearintl2) = integrand2d(NearIntLength, nearintl2) + &
                           B2/(sigmaTTT)*(Dummyell)**4/(4.d0*pi**3)*(4.d0)**2
                   endif

                   !write(*,*) DSN1

                enddo
                DSN2 = DSN2 + DSN1*(Dummyell)

             enddo
             DSN3 = DSN3 + DSN2*(Dummyell)
          enddo
          DSN4 = DSN4 + DSN3*(Dummyell)
          write(*,*) lx1, ly1, lx2, ly2, DSN4,sqrt((4.d0*pi**3)/DSN4)
       enddo
       !$OMP END PARALLEL DO

       open(unit=8,file = '../data/integrand2d_CV_r_0.01_GRID_ttt.dat', &
            form='unformatted', status="replace",access='direct', recl = 8 * (lmaxScal/Dummyell) * (lmaxScal/Dummyell))
       write(unit=8,rec=1) integrand2d(:,:) 
       close(unit=8)
       deallocate(integrand2d)

    else 
       open(unit=28,file='../data/SN_TTT2D_CMB-S4xCMB-S4_GRIDell_local2.txt', status="replace")

       Dummyell = 20
       deltaell = Dummyell
       write(*,'(A40)') "<<<<<<<<<<<< Computing S/N >>>>>>>>>>>>>"
       DSN4 = 0.d0
       !!from Hu: http://journals.aps.org/prd/pdf/10.1103/PhysRevD.62.043007, Eq. C22
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(lx1,lx2,ly1,ly2,s1,s2,s3,y1), &
       !$OMP PRIVATE(DSN1,DSN2,DSN3,DSN4), &
       !$OMP PRIVATE(lengthl1l2,NearIntLength,NearIntl1,NearIntL2), &	
       !$OMP PRIVATE(B2,sigmaTTT,ell1,l1crossl2,lengthl1,lengthl2)	
       do il = 100, 3000, 290
          !write (*, *) 'loop for BTT', il , OMP_GET_THREAD_NUM()
          DSN4 = 0.d0

          do lx1 = -il, il-1, Dummyell
             DSN3 = 0.d0
             do ly1 = -il , il-1, Dummyell
                DSN2 = 0.d0
                do lx2 = -il, il-1, Dummyell
                   DSN1 = 0.d0
                   do ly2 = -il, il-1, Dummyell

                      !very approximate for now:
                      lengthl1l2 = sqrt(1.d0*(lx1**2+lx2**2+2*lx1*lx2 + ly1**2+ly2**2+2*ly1*ly2))
                      lengthl1 = sqrt(1.d0*(lx1**2+ly1**2))
                      lengthl2 = sqrt(1.d0*(lx2**2+ly2**2))

                      l1crossl2 = lx1*ly2-ly1*lx2
                      NearIntLength =nint(abs(lengthl1l2-lmin)/deltaell)
                      !write(*,*) NearIntLength,  lx1, lx2, ly1, ly2
                      NearIntl1 = nint(abs(lengthl1-lmin)/deltaell)
                      NearIntL2 = nint(abs(lengthl2-lmin)/deltaell)


                      if (NearIntl1 .le. 0) NearIntl1 = 1
                      if (NearIntl2 .le. 0) NearIntl2 = 1
                      if (NearIntLength .le. 0) NearIntLength = 1

                      if(lengthl1 .gt. il .or. lengthl2 .gt. il .or. lengthl1l2 .gt. il .or. &
                           lengthl1 .lt. 10 .or. lengthl2 .lt. 10 .or. lengthl1l2 .lt. 10) then 
                         B2 = 0.0
                         sigmaTTT = 1.0 !needed for OMP
                      else
                         if (do_log_ell) then
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl1,s1)
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl2,s2)
                            !write(*,*) lengthl1l2
                            call OneDlinear_IrrGrid_interpolation(lmin,testlmax,ClTT,lengthl1l2,s3)
                         else                           
                            call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl1,lstep,s1)
                            call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl2,lstep,s2)
                            call OneDlinear_interpolation(lmin,testlmax,ClTT,lengthl1l2,lstep,s3)
                         endif
                         !sigma in case with/without noise (+ cv)
                         if (cosmic_variance) then 
                            !sigmaBTT = Bnoise(9+int(deltaell)*(NearIntLength-1))*s1*s2*(2*pi)**2
                            sigmaTTT = s3*s1*s2*(2*pi)**3
                         else
                            !sigmaTTT = (ClTT(NearIntLength)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                            !     (ClTT(NearIntL2)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))* &
                            !     (ClTT(NearIntl1)*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1)))
                            sigmaTTT = (s3*(2*pi)+Tnoise(9+int(deltaell)*(NearIntLength-1)))* &
                                 (s1*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL1-1))) &
                                 *(s2*(2*pi)+Tnoise(9+int(deltaell)*(NearIntL2-1)))
                         endif
                         if (do_log_ell) then
                            call ThreeDlinear_IrrGrid_interpolation(lmin,testlmax,testlmax,blll,lengthl1l2,lengthl2,lengthl1,y1)
                         else
                            call ThreeDlinear_interpolation(lmin,testlmax,testlmax,blll,lengthl1l2,lengthl2,lengthl1,lstep,y1)
                         endif

                         B2 = y1**2
                         DSN1 = DSN1 + B2/(sigmaTTT)*(Dummyell) !*real(l1crossl2)**2/lengthl1l2**2/lengthl1**2
                      endif
                   enddo
                   DSN2 = DSN2 + DSN1*(Dummyell)
                enddo
                DSN3 = DSN3 + DSN2*(Dummyell)
             enddo
             DSN4 = DSN4 + DSN3*(Dummyell)
          enddo
          DSN4 = DSN4/(4.d0*pi**3)

          write(28,*) lx1, sqrt(1.d0/DSN4)
          write(*,*) lx1, sqrt(1.d0/DSN4)
       enddo
       !$OMP END PARALLEL DO 
       close(28)
    endif

    deallocate(Blll)
    if (want3D) deallocate(w3j)



  end subroutine Get_SN_TTT

  real function Noise_l(sigmab,w0,ell)
    real(dl) :: sigmab
    real(dl) :: w0
    integer :: ell
    real(dl) :: arcmin
    real(dL) :: fac
    arcmin = 0.000290888
    fac = arcmin / 2.d0*sqrt(2.d0*log(2.d0))

    Noise_l = w0**2*arcmin**2*exp(ell**2*fac**2*sigmab**2)
    
  end function Noise_l
end module modules
